﻿using MVVMbasics.Viewmodels;
using System;
using MVVMbasics.Commands;
using MVVMbasics.Services;
using SimpleChat.Services;

namespace SimpleChat.Viewmodels
{
	public class LoginViewmodel : BaseViewmodel
	{
		private string _name;
		public string Name
		{
			get { return _name; }
			set { Set(ref _name, value, () => NotifyPropertyChanged(() => Username)); }
		}

		private int _age;
		public int Age
		{
			get { return _age; }
			set { Set(ref _age, value, () => NotifyPropertyChanged(() => Username)); }
		}

		public string Username
		{
			get { return String.Format("{0} ({1})", Name, Age); }
		}

		public BaseCommand LoginCommand { get; set; }

		public LoginViewmodel()
		{
			LoginCommand = CreateCommand(Login,
				() => !String.IsNullOrEmpty(Name) && Age >= 18);
		}

		private async void Login()
		{
			int userId = 0;
			try
			{
				userId = await ServiceLocator.Retrieve<BackendService>().LoginAsync(Username);
			}
			catch
			{
				ServiceLocator.RetrieveOnce<IMessageboxService>().Show("Fehler bei der Anmeldung!");
				return;
			}

			ServiceLocator.Retrieve<INavigatorService>().NavigateTo<ChatViewmodel>("user", userId);
		}
	}
}
